/* Build with
   gcc -o hello-world-c `pkg-config --cflags --libs gtk+-3.0` -Wall hello-world.c
 */

#include <gtk/gtk.h>

static void
on_clicked_1 (GtkWidget *widget,
	      gpointer   user_data)
{
	g_print ("Hello World\n");
}

static void
on_clicked_2 (GtkWidget *widget,
	      gpointer   user_data)
{
	gtk_widget_destroy (GTK_WIDGET (user_data));
}

static gboolean
on_delete (GtkWidget *widget,
	   gpointer   user_data)
{
	g_print ("delete event\n");
	return FALSE;
}

static void
on_destroy (GtkWidget *widget,
	    gpointer   user_data)
{
	g_print ("destroy signal\n");
	gtk_main_quit ();
}

int
main (int argc, char **argv)
{
	GtkWidget *window;
	GtkWidget *button;

	gtk_init (&argc, &argv);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	g_signal_connect (window, "delete-event",
			  G_CALLBACK (on_delete), NULL);
	g_signal_connect (window, "destroy",
			  G_CALLBACK (on_destroy), NULL);

	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	button = gtk_button_new_with_label ("Hello World");

	g_signal_connect (button, "clicked",
			  G_CALLBACK (on_clicked_1), NULL);

	g_signal_connect (button, "clicked",
			  G_CALLBACK (on_clicked_2), window);

	gtk_container_add (GTK_CONTAINER (window), button);

	gtk_widget_show_all (GTK_WIDGET (window));

	gtk_main ();

	return 0;
}
